/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 03/11/2017
 --------------------------------------------------------
*/
package com.portofolio.entity;


import org.hibernate.annotations.ForeignKey;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;

import javax.persistence.*;
import javax.validation.constraints.*;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.Profile;
import com.portofolio.entity.vo.MapObjekModulToKelompokUserId;

import org.hibernate.annotations.Type;



@Entity
@Table(name = "MapObjekModulToKelompokUser_S",indexes = {@Index(name = "MapObjekModulToKelompokUser_S_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class MapObjekModulToKelompokUser {
    
    @EmbeddedId
    private MapObjekModulToKelompokUserId id ;
    
    private static final String cDefSimpan =INTEGER;
    @Column(name = "Simpan", columnDefinition = cDefSimpan)
    @NotNull(message = "mapobjekmodultokelompokuser.simpan.notnull")
    private Integer simpan;
    
    private static final String cDefHapus =INTEGER;
    @Column(name = "Hapus", columnDefinition = cDefHapus)
    @NotNull(message = "mapobjekmodultokelompokuser.hapus.notnull")
    private Integer hapus;
    
    private static final String cDefUbah =INTEGER;
    @Column(name = "Ubah", columnDefinition = cDefUbah)
    @NotNull(message = "mapobjekmodultokelompokuser.ubah.notnull")
    private Integer ubah;
    
    private static final String cDefCetak =INTEGER;
    @Column(name = "Cetak", columnDefinition = cDefCetak)
    @NotNull(message = "mapobjekmodultokelompokuser.cetak.notnull")
    private Integer cetak;
    
    private static final String cDefTampil =INTEGER;
    @Column(name = "Tampil", columnDefinition = cDefTampil)
    @NotNull(message = "mapobjekmodultokelompokuser.tampil.notnull")
    private Integer tampil;
    
    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "mapobjekmodultokelompokuser.statusenabled.notnull")
    @Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;
    
    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "mapobjekmodultokelompokuser.norec.notnull")
    private String noRec;
    
    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "mapobjekmodultokelompokuser.version.notnull")
    private Integer version;
    

    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Profile profile;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdKelompokUser", referencedColumnName="KdKelompokUser",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private KelompokUser kelompokUser;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdObjekModulAplikasi", referencedColumnName="KdObjekModulAplikasi",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private ObjekModulAplikasi objekModulAplikasi;
}
